# malloc.c File Reference

## Detailed Description

Dynamic memory allocation services.

Author:
  Philippe Gerum

Copyright (C) 2001,2002,2003,2004 Philippe Gerum <rpm@xenomai.org>.

RTAI is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

RTAI is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with RTAI; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

Dynamic memory allocation services lifted and adapted from the Xenomai nucleus.

This file implements the RTAI dynamic memory allocator based on the algorithm described in "Design of a General Purpose Memory Allocator for the 4.3BSD Unix Kernel" by Marshall K. McKusick and Michael J. Karels.

Include dependency graph for malloc.c:

## Functions

int | rtheap_init (rtheap_t *heap, void *heapaddr, u_long heapsize, u_long pagesize)
| Initialize a memory heap.
void | rtheap_destroy (rtheap_t *heap)
| Destroys a memory heap.
void * | rtheap_alloc (rtheap_t *heap, u_long size, int mode)
| Allocate a memory block from a memory heap.
int | rtheap_free (rtheap_t *heap, void *block)
| Release a memory block to a memory heap.